
schemes <- {}
scheme_weights <- {}

foreach (name in split(@"
  utils
  basic
  mods
  events
  places
  universe
  save
  ", " \t\r\n")) include("gen/"+name+".nut")


in_main_menu <- false
cur_world <- null
universe <- null


function generate_world(reason)
{
  in_main_menu=(reason=="main_menu")

  // foreach (pal in world_palettes)
  // {
  //   print("!!! palette "+pal.name+"\n");
  //   foreach (k,v in pal) print("  "+k+" = "+v+"\n");
  // }

  // print("===\nname,rock1,rock2,rock3,rock4,grass,leaves\n");
  // for (local pi=1; pi<=30; ++pi)
  // {
  //   print(format("pal%02d,", pi));

  //   local range0=5, range1=5, range2=45, ofs1=90, ofs2=180, baseHue=frnd()*360

  //   local hofs=frnd(), sofs=frnd(), vofs=frnd()
  //   for (local i=0; i<4; ++i)
  //   {
  //     local v=(vofs+GOLD_RATIO*i)%1*0.8+0.1
  //     local s=(sofs+GOLD_RATIO*i)%1*0.5+0.5

  //     local c=hsv2rgba(
  //       baseHue+random_hue_harmony((hofs+GOLD_RATIO*i)%1, range0, range1, range2, ofs1, ofs2),
  //       s*(1-v), v, 0)
  //     print(format("0x%08X,", tocolor(c)));
  //   }

  //   print(format("0x%08X,", tocolor(hsv2rgba(rndf(0, 110), 0.61+srnd()*0.1, rndf(0.4, 0.5), 1))));
  //   print(format("0x%08X\n", tocolor(hsv2rgba(84+srnd()*5, 0.71+srnd()*0.1, rndf(0.4, 0.5), 1))));
  // }

  local s
  cur_mod=MultiModifier()

  local w=null
  if (universe && universe.enteredWorld>=0
    && universe.enteredWorld<universe.worlds.len())
      w=universe.worlds[universe.enteredWorld]

  if (w)
  {
    cur_world=w
    cur_world.visited=true
    print(format("entering world #%d\n", w.id))

    set_rnd_seed(w.seed)
    if (reason!="test_pal")
      cur_world_pal=get_world_pal(format("pal%02d", irnd()%30+1)) //== use pal from uni data

    set_rnd_seed(w.seed)
    reseed_noise()

    s=w.scheme
    print(format("using world scheme '%s'\n", s))

    foreach (m in w.mods)
    {
      print(format("  using mod '%s'\n", m))
      cur_mod.subs.append(modifiers[m]())
    }
  }
  else
  {
    cur_world=null

    if (reason!="test_pal")
    {
      cur_world_pal=get_world_pal(format("pal%02d", irnd()%30+1))
      // cur_world_pal=get_world_pal("pal04")
      print(format("using world palette '%s'\n", cur_world_pal.name))
    }

    // set_rnd_seed(1234)
    reseed_noise()

    s=choose_scheme(frnd())
    // s="hills1" //==
    print(format("using world scheme '%s'\n", s))

    foreach (m in modifiers)
      if (frnd()<m.chance)
      {
        print(format("  using mod '%s'\n", m.name))
        cur_mod.subs.append(m())
      }

    if (in_main_menu)
    {
      for (local n=irnd()%2+2; n; --n)
        cur_mod.subs.append(VolcanoMod())
    }
  }

  reset_places()
  cur_mod.reset()

  if (reason!="test_pal")
  {
    local ha=frnd()*PI*2, va=rndf(-5, 30)*PI/180
    set_sun_dir(make4f(cos(ha)*cos(va), sin(va), sin(ha)*cos(va), 0))
  }

  create_magic_places()

  schemes[s]()

  recenter_hmap()

  mark_water(0.1, MARK_WATER, 0)

  cur_mod.beforeObjects()

  local count=0
  for (local n=irnd()%800+0; n>0; --n)
    if (place_object(TreeObject(hmfrnd(), hmfrnd(),
      get_pal_color(cur_world_pal, "leaves"),
      get_pal_color(cur_world_pal, "trunk")))) ++count
  print(format("placed %d trees\n", count))

  if (in_main_menu)
  {
    // for (local n=20; n>0; --n)
    // {
    //   local ws=add_water_source(vec4f(hmrnd(), 0, hmrnd(), 1), 3, 5)
    //   if (ws) ws.setHidden(true)

    //   ws=add_water_source(vec4f(hmrnd(), 0, hmrnd(), 1), 3, -5)
    //   if (ws) ws.setHidden(true)
    // }

    // local dt=0.05, tt=60.0*0.5
    // for (local t=0; t<tt; t+=dt)
    // {
    //   show_splash("Simulating water", t/tt)
    //   simulate_water(dt)
    // }

    foreach (p in places)
      if (frnd()<0.5) SpellObject(p.cx, p.cz, ID_FireballSpell)
  }
  else
  {
    // NaturalVolcano(vec4f(0, 0, 0, 1), 7,
    //   vec4f(4, 30,  0, 0),
    //   vec4f(8, 60,  5, 0))
    // add_water_source(vec4f(0, 0, 10, 1), 3, 5)
  }

  // LandMonster(vec4f(0, 0, 10, 1), vec4f(1, 0, 0, 0)) //==
  // apply_water_mask(null, @(w) w+3)
  // repaint_land(function(x, z, bc, sc)
  // {
  //   if ((x&3)==0) return [bc, GT_ROCK]
  //   return [bc, GT_ROCK, sc, ST_GRASS]
  // })
  // print("grass color: "+get_pal_color(cur_world_pal, "grass")+"\n")

  cur_mod=null

  update_check_delay=0.0
}
